/*
Copyright (C) 2006 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef SIB_05302007_H_
#define SIB_05302007_H_

#include <stdint.h>

struct SIB {
public:
	SIB(uint8_t value) : m_Value(value) {}
private:
	union {
		struct {
		uint8_t Base  : 3;
		uint8_t Index : 3;
		uint8_t Scale : 2;
		} m_Bits;

		uint8_t m_Value;
	};
public:	
	uint8_t base() const	{ return m_Bits.Base; }
	uint8_t index() const	{ return m_Bits.Index; }
	uint8_t scale() const	{ return m_Bits.Scale; }
};

#endif

